package gq.unurled.raxen.components.dungeons;

import com.onarandombox.MultiverseCore.api.MVWorldManager;
import com.onarandombox.MultiverseCore.api.MultiverseWorld;
import gq.unurled.raxen.Raxen;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static gq.unurled.raxen.utils.Utils.*;

public class WorldManagement {

    private Raxen main;

    MVWorldManager worldManager;

    /**
     * String : name
     * MultiverseWorld : a world that need to be registered
     */
    private Map<String, MultiverseWorld> loadedWorlds = new HashMap<>();
    
    private List<String> worlds = new ArrayList<>();

    private File pluginFolder;
    private File worldFolder;


    public WorldManagement(Raxen main) {
        this.main = main;
        this.pluginFolder = new File(main.getDataFolder() + "/worlds/");
        this.worldFolder = new File("worlds/");
        this.worldManager = main.getManager().getMultiverse().getWorldManager();
        worlds.add("Forest");
        log(pluginFolder.getAbsolutePath(), "" + pluginFolder.isDirectory());
        log(worldFolder.getAbsolutePath(), "" + worldFolder.isDirectory());
    }

    public void load() {
        if (!pluginFolder.exists()) {
            pluginFolder.mkdirs();
            error("Please put in the folder " + pluginFolder.getAbsolutePath() + " all the needed worlds :");
            for (String s : worlds) {
                error(" - " + s + ",");
            }
        }
    }

    public void loadWorld(String name) {
        File world = new File(pluginFolder + name + "/");
        if (!world.exists() || !world.isDirectory()) {
            error("Loading world " + name + ". Folder don't exists.");
        }
        File newWorld = new File(worldFolder + name);
        try {
            copyDirectory(world.getAbsolutePath(), newWorld.getAbsolutePath());
        } catch (IOException e) {
            error("Error while Loading world " + name + " at coping data.");
            e.printStackTrace();
        }
        worldManager.loadWorld(name);
    }

}
