package gq.unurled.raxen.components.entity.other;

import gq.unurled.raxen.Raxen;
import lombok.Getter;
import lombok.Setter;
import net.kyori.adventure.text.Component;
import org.bukkit.Location;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

public class RaxenEntity {

    private final Raxen main;

    @Getter private final String name;

    @Getter private Integer level;

    @Getter @Setter private Double health;

    @Getter @Setter private Double strength;

    @Getter @Setter Boolean isAlive = false;

    public RaxenEntity(Raxen main, String name, Integer level, Double health, Double strength) {
        this.main = main;
        this.name = name;
        this.level = level;
        this.health = health;
        this.strength = strength;
    }

    public Entity createEntity(EntityType types, String name, Location location) {
        Entity e = location.getWorld().spawnEntity(location, types);
        e.setCustomNameVisible(true);
        e.customName(Component.text(name));

        return e;
    }

    public void register(Entity e) {
        PersistentDataContainer data  = e.getPersistentDataContainer();
        data.set(new NamespacedKey(main ,"NAME"), PersistentDataType.STRING, name);
    }

    public Double getMaxHealth(Entity e) {
        PersistentDataContainer data  = e.getPersistentDataContainer();
        EntityNamespacedKey key = new EntityNamespacedKey(main);
        return data.get(key.maxHealth, PersistentDataType.DOUBLE);
    }

}
