package gq.unurled.raxen.components.entity.player;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.entity.other.EntityNamespacedKey;
import gq.unurled.raxen.components.entity.player.attributes.Attribute;
import gq.unurled.raxen.components.entity.player.storages.EnderChest;
import gq.unurled.raxen.components.entity.player.storages.Inventory;
import gq.unurled.raxen.utils.EntityAttributes;
import gq.unurled.raxen.utils.Items;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.ItemStack;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

import java.util.ArrayList;
import java.util.List;

import static gq.unurled.raxen.utils.Items.setItemsToInventory;
import static gq.unurled.raxen.utils.Utils.debug;

public class RaxenPlayer {

    private final Raxen main;
    private final Player player;
    private final EntityNamespacedKey namespacedKey;

    private Boolean isRaxenPlayer;

    private Attribute attribute;

    private Storage storages;
    private Inventories inventory;

    public RaxenPlayer(Raxen main, Player player) {
        this.main = main;
        this.player = player;
        this.namespacedKey = new EntityNamespacedKey(main);
        this.isRaxenPlayer = true;
    }

    public Attribute createNewAttribute() {
        debug(main, "Created new Attribute");
        EntityAttributes.setAttributes(player, 100, 100,0,50,0,100,0,100,0, 100, 100, 0, 10, 0);
        return new Attribute(100,100,0,50,0,100,0,100,0, 100, 100, 0, 10, 0);
    }

    public void setStorages(org.bukkit.inventory.Inventory inv, org.bukkit.inventory.Inventory ec) {
        setStorage(ec);
        setInventory(inv);
    }

    public Storage getStorage() {
        PersistentDataContainer data = player.getPersistentDataContainer();
        String store = data.get(namespacedKey.storage, PersistentDataType.STRING);
        org.bukkit.inventory.Inventory ec = Bukkit.createInventory(null, 54, Component.text("Ender Chest"));
        ec = setItemsToInventory(Items.listItemStackDeserilize(store), ec);
        EnderChest ecc = new EnderChest(ec);
        Storage storage = new Storage(ecc);
        return storage;
    }

    public Inventories getInventory() {
        PersistentDataContainer data = player.getPersistentDataContainer();
        String inv = data.get(namespacedKey.inventory, PersistentDataType.STRING);
        org.bukkit.inventory.Inventory invv = Bukkit.createInventory(player, InventoryType.PLAYER);
        invv = setItemsToInventory(Items.listItemStackDeserilize(inv), invv);
        Inventory invvv = new Inventory(invv);
        Inventories invvvv = new Inventories(invvv);
        return invvvv;
    }

    public void setInventory(org.bukkit.inventory.Inventory inv) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        List<String> listInv = new ArrayList<String>();
        Integer reverse = 0;
        for(ItemStack it : inv) {
            reverse = reverse + 1;
            if(it != null && it.getType() != Material.AIR) {
                String s = Items.itemStackSerilize(it, reverse);
                listInv.add(s);
            }
        }
        String invv = Items.listItemStackSerelize(listInv);
        this.inventory = new Inventories(new Inventory(inv));
        data.set(namespacedKey.inventory, PersistentDataType.STRING, invv);
    }

    public void setStorage(org.bukkit.inventory.Inventory ec) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        List<String> list = new ArrayList<String>();
        int reverse = 0;
        for(ItemStack it : ec) {
            if(it != null) {
                String s = Items.itemStackSerilize(it, reverse);
                list.add(s);
            }
            reverse += 1;
        }
        String store = Items.listItemStackSerelize(list);
        this.storages = new Storage(new EnderChest(ec));
        data.set(namespacedKey.storage, PersistentDataType.STRING, store);
    }

    public Storage createStorage() {
        setStorage(Bukkit.createInventory(null, 54, Component.text("Ender Chest")));
        return getStorage();
    }

    public Inventories createInventory() {
        setInventory(Bukkit.createInventory(null, InventoryType.PLAYER));
        return getInventory();
    }

    public Boolean isRaxenPlayer() {
        return isRaxenPlayer;
    }

    public void isRaxenPlayer(boolean player) {
        isRaxenPlayer = player;
    }

    public Attribute getAttribute() {
        return attribute;
    }
}
