package gq.unurled.raxen.listener.entity;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.entity.other.EntityNamespacedKey;
import gq.unurled.raxen.components.entity.other.EntityUtils;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntitySpawnEvent;
import org.bukkit.persistence.PersistentDataType;

import static gq.unurled.raxen.utils.Utils.debug;

public class SpawnEvent implements Listener {

    private Raxen main;
    private EntityUtils entityUtils;
    private EntityNamespacedKey namespacedKey;

    public SpawnEvent(Raxen main) {
        this.main = main;
        this.entityUtils = new EntityUtils(main);
        this.namespacedKey = new EntityNamespacedKey(main);
    }

    @EventHandler
    public void Spawn(EntitySpawnEvent e) {
        if (e.getEntity() instanceof Player) {
            //player stuff dont want to talk about it;
            debug(main, "Player: " + ((Player) e.getEntity()).getName());
        } else if (e.getEntity().getType() != EntityType.DROPPED_ITEM && e.getEntity().getType() != EntityType.FALLING_BLOCK) {
            debug(main, e.getEntity().getName());
            if (!e.getEntity().getPersistentDataContainer().has(namespacedKey.name, PersistentDataType.STRING)) {
                entityUtils.setNameSpacedKeys(e.getEntity(), e.getEntityType().name(), 1, 10, 0, 50, 0, 100, 0, 100, 0);
            }
            entityUtils.updateSkills((LivingEntity) e.getEntity());
        }
    }
}
