package gq.unurled.raxen.listener.player;

import de.tr7zw.nbtapi.NBTItem;
import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.entity.player.PlayerUtils;
import gq.unurled.raxen.components.entity.player.attributes.Attributes;
import gq.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerItemHeldEvent;
import org.bukkit.inventory.ItemStack;

public class ItemHandEvent implements Listener {

    private Raxen main;

    public ItemHandEvent(Raxen main) {
        this.main = main;
    }

    @EventHandler
    public void ItemHeldEvent(PlayerItemHeldEvent e) {
        Player player = e.getPlayer();
        PlayerManager pm = ((Raxen) Bukkit.getPluginManager().getPlugin("Raxen")).getManager().getPlayerManager();
        Entity entity = player;
        Attributes attributes = new Attributes(main);
        ItemStack oldItem = player.getInventory().getItem(e.getPreviousSlot());
        ItemStack newItem = player.getInventory().getItem(e.getNewSlot());
        if(oldItem != null && oldItem.getType() != Material.AIR) {
            NBTItem nbti = new NBTItem(oldItem);
            if(nbti.hasKey("SPEED")) {
                pm.getItemSpeed().remove(player, nbti.getInteger("SPEED"));
            }
            if(nbti.hasKey("HEALTH")) {
                pm.getItemHealth().remove(player, nbti.getInteger("HEALTH"));

            }
            if(nbti.hasKey("DEFENSE")) {
                pm.getItemDefense().remove(player, nbti.getInteger("DEFENSE"));

            }
            if(nbti.hasKey("STRENGTH")) {
                pm.getItemStrength().remove(player, nbti.getInteger("STRENGTH"));

            }
        }
        if(newItem != null && newItem.getType() != Material.AIR) {
            NBTItem nbti = new NBTItem(newItem);
            if(nbti.hasKey("SPEED")) {
                pm.getItemSpeed().add(player, nbti.getInteger("SPEED"));
            }
            if(nbti.hasKey("HEALTH")) {
                pm.getItemHealth().add(player, nbti.getInteger("HEALTH"));

            }
            if(nbti.hasKey("DEFENSE")) {
                pm.getItemDefense().add(player, nbti.getInteger("DEFENSE"));

            }
            if(nbti.hasKey("STRENGTH")) {
                pm.getItemStrength().add(player, nbti.getInteger("STRENGTH"));

            }
        }
        PlayerUtils.updateSkills(main, player);
    }
}
