package gq.unurled.raxen.listener.player;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.entity.player.Scoreboard;
import gq.unurled.raxen.components.resourcepack.ResourcePack;
import gq.unurled.raxen.config.PlayerConfig;
import gq.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;

public class JoinEvent implements Listener {

    private Raxen main;
    private PlayerConfig playerConfig;
    private Scoreboard scoreboard;
    private ResourcePack resourcePack;
    private PlayerManager playerManager;

    public JoinEvent(Raxen main) {
        this.main = main;
        this.playerConfig = main.getPlayerConfig();
        this.scoreboard = new Scoreboard(main);
        this.resourcePack = main.getManager().getResourcePackManager().getResourcePack();
        this.playerManager = main.getManager().getPlayerManager();
    }

    @EventHandler
    public void PlayerJoinEvent(PlayerJoinEvent e) {
        Player player = e.getPlayer();
        playerConfig.loadPlayerConfig(player);
        scoreboard.createScorebord(player);
        resourcePack.join(player);
        playerManager.getRaxenPlayer(player).isRaxenPlayer(true);
        playerManager.registerActionBar(player);
    }

}
