package gq.unurled.raxen.manager;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.manager.entity.*;
import gq.unurled.raxen.manager.server.*;
import gq.unurled.raxen.utils.libs.Multiverse;
import lombok.Getter;

public class Manager {

    @Getter
    private WorldManager worldManager;
    @Getter
    private StorageManager storageManager;
    @Getter
    private PlayerManager playerManager;
    @Getter
    private ListenerManager listenerManager;
    @Getter
    private CommandManager commandManager;
    @Getter
    private ItemManager itemManager;
    @Getter
    private ResourcePackManager resourcePackManager;
    @Getter
    private EntityManager entityManager;
    @Getter
    private LootManager lootManager;
    @Getter
    private LibsManager libsManager;

    @Getter private Multiverse multiverse;

    public void set(Raxen main) {
        libsManager = new LibsManager(main);

        worldManager = new WorldManager(main);
        storageManager = new StorageManager(main);

        //Managers
        itemManager = new ItemManager(main);
        playerManager = new PlayerManager(main);
        listenerManager = new ListenerManager(main);
        commandManager = new CommandManager(main);
        resourcePackManager = new ResourcePackManager(main);
        entityManager = new EntityManager(main);
        lootManager = new LootManager(main);
        multiverse = new Multiverse();
    }
}
