package gq.unurled.raxen.manager.server;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.listener.entity.DamageEntity;
import gq.unurled.raxen.listener.entity.SpawnEvent;
import gq.unurled.raxen.listener.player.*;
import gq.unurled.raxen.utils.Reload;
import lombok.Getter;
import org.bukkit.plugin.PluginManager;

public class ListenerManager {

    private final Raxen main;
    private final PluginManager pm;
    @Getter
    private ServerPingEvent serverPingEvent;

    public ListenerManager(Raxen main) {
        this.main = main;
        this.pm = main.getPm();
        this.serverPingEvent = new ServerPingEvent(main);
    }

    public void register() {
        this.pm.registerEvents(new JoinEvent(main), main);
        this.pm.registerEvents(new LeaveEvent(main), main);
        this.pm.registerEvents(new ArmorEvent(main), main);
        this.pm.registerEvents(new ItemHandEvent(main), main);
        this.pm.registerEvents(new Reload(), main);
        this.pm.registerEvents(new TransactionEvent(main), main);
        this.pm.registerEvents(main.getManager().getCommandManager().getItemListCommand().getItemListGui(), main);
        this.pm.registerEvents(new DamageEntity(main), main);
        this.pm.registerEvents(new SpawnEvent(main), main);
        this.pm.registerEvents(new ClickBlockEvent(main), main);
        this.pm.registerEvents(serverPingEvent, main);
        this.pm.registerEvents(new CloseInventoryEvent(), main);

    }
}
